//
// Telnet BBS Guide to Mystic BBS List converter.
//
// By Darryl Perry, AKA Gryphon 2016
// Call Cyberia BBS
// telnet://cyberia.darktech.org
//
// This script will read the full Telnet BBS Guide
// list and create a Mystic-Native BBS List BBI file
// in the Mystic Data directory.
//
// Install:
// 1) Copy tbg2mys.mps to the Mystic scripts directory
//    and compile it with mplc or mide:
//    # ./mplc tbg2mys
// 2) Copy the Full_Mon_YY.txt file to the Mystic TEXT
//    directory and name it tbg.txt.
//    ie. <MYSTIC>/text/tbg.txt
//    ie. <MYSTIC>\TEXT\TBG.TXT
// 3) Run tbg2mys:
//    Menu : GX
//    Data : tbg2mys
//
//    The MPL will then create the file 'tbg.bbi' in the
//    Mystic DATA directory:
//    ie. <MYSTIC>/data/tbg.bbi
//    ie. <MYSTIC>\DATA\TBG.BBI
//
// 4) Create a menu option to view the list:
//    Menu : BS <-- short list
//    Data : tbg /SEARCH
//    Menu : BL <-- long list
//    Data : tbg /SEARCH

Uses Cfg
Uses User

Type
   BBSListRec = Record
 		CType	 	:Byte
		Phone	 	:String[15]
		Telnet 	:String[40]
		Name   	:String[30]
		Location:String[25]
		Sysop  	:String[30]
		Baud	 	:String[6]
		Software:String[10]
		Deleted :Boolean
		AddedBy :String[30]
		Verified:LongInt
		Extra1 	:LongInt
		Extra2 	:Integer
End

Var InFile	: String
Var OutFile	: String
Var TStr		: String
Var InPtr		: File
Var OutPtr	: File
Var Lines		: Array [1..20] Of String
Var BBS			: BBSListRec

Procedure Main
Var X	: Integer
Begin
	fAssign(OutPtr,OutFile,66)
	fRewrite(OutPtr)

	fAssign(InPtr,InFile,66)
	fReset(InPtr)
	If IoResult = 0 Then Begin
		While Not fEof(InPtr) Do Begin

			For X:=10 Down To 2 Do Lines[X]:=Lines[X-1]		

			fReadLn(InPtr,Lines[1])
	
			If Pos('Software:',Lines[1])>0 Then Begin
				BBS.Name:=StripB(Replace(Lines[10],'*',''),' ')
				WriteLn('|CRBBS Name : '+BBS.Name)
				BBS.Telnet:=StripB(Copy(Lines[7],12,Length(Lines[7])-11),' ')
				WriteLn('Telnet : '+BBS.TElnet)
				BBS.Location:=StripB(Copy(Lines[3],12,Length(Lines[3])-11),' ')
				WriteLn('Location : '+BBS.Location)
				BBS.Software:=StripB(Copy(Lines[1],12,20),' ')
				WriteLn('Software : '+BBS.Software)
				BBS.Baud:=StripB(Copy(Lines[1],45,4),' ')
				WriteLn('Baud: '+BBS.Baud)
				BBS.Phone:=StripB(Copy(Lines[2],12,12),' ')
				WriteLn('Phone: '+BBS.Phone)
				If BBS.Phone <> '' And BBS.Telnet <> '' Then Begin
					BBS.CType:=2
				End Else 
					If BBS.Phone <> '' Then 
						BBS.CType:=0
					Else 
						BBS.CType:=1

				BBS.Deleted:=False
				BBS.AddedBy:=StripMCI(UserAlias)
				BBS.Verified:=DateTime
				fWriteRec(OutPtr,BBS)
			End
		End
		fClose(InPtr)
	End


	fClose(OutPtr)
End

Begin
	GetThisUser
	InFile:=CfgTextPath+'tbg.txt'
	OutFile:=CfgDataPath+'tbg.bbi'
	Main
End
